package greenfoot;

public final class Color
{
	public static final Color black = new Color(android.graphics.Color.BLACK);
	public static final Color BLACK = new Color(android.graphics.Color.BLACK);
	public static final Color blue = new Color(android.graphics.Color.BLUE);
	public static final Color BLUE = new Color(android.graphics.Color.BLUE);
	public static final Color cyan = new Color(android.graphics.Color.CYAN);
	public static final Color CYAN = new Color(android.graphics.Color.CYAN);
	public static final Color DARK_GRAY = new Color(android.graphics.Color.DKGRAY);
	public static final Color darkGray = new Color(android.graphics.Color.DKGRAY);
	public static final Color gray = new Color(android.graphics.Color.GRAY);
	public static final Color GRAY = new Color(android.graphics.Color.GRAY);
	public static final Color green = new Color(android.graphics.Color.GREEN);
	public static final Color GREEN = new Color(android.graphics.Color.GREEN);
	public static final Color LIGHT_GRAY = new Color(android.graphics.Color.LTGRAY);
	public static final Color lightGray = new Color(android.graphics.Color.LTGRAY);
	public static final Color magenta = new Color(android.graphics.Color.MAGENTA);
	public static final Color MAGENTA = new Color(android.graphics.Color.MAGENTA);
	public static final Color orange = new Color(android.graphics.Color.rgb(255, 165, 0));
	public static final Color ORANGE = new Color(android.graphics.Color.rgb(255, 165, 0));
	public static final Color pink = new Color(android.graphics.Color.rgb(255, 192, 203));
	public static final Color PINK = new Color(android.graphics.Color.rgb(255, 192, 203));
	public static final Color red = new Color(android.graphics.Color.RED);
	public static final Color RED = new Color(android.graphics.Color.RED);
	public static final Color white = new Color(android.graphics.Color.WHITE);
	public static final Color WHITE = new Color(android.graphics.Color.WHITE);
	public static final Color yellow = new Color(android.graphics.Color.YELLOW);
	public static final Color YELLOW = new Color(android.graphics.Color.YELLOW);
	
	private int value;
	
	public Color(float r, float g, float b){
		int R = (int)(r * 256);
		int G = (int)(g * 256);
		int B = (int)(b * 256);
		value = android.graphics.Color.rgb(R, G, B);
	}
	
	public Color(float r, float g, float b, float a){
		int A = (int)(a * 256);
		int R = (int)(r * 256);
		int G = (int)(g * 256);
		int B = (int)(b * 256);
		value = android.graphics.Color.argb(A, R, G, B);
	}
	
	public Color(int color){
		value = color;
	}
	
	public Color(int r, int g, int b){
		value = android.graphics.Color.rgb(r, g, b);
	}
	
	public Color(int r, int g, int b, int a){
		value = android.graphics.Color.argb(a, r, g, b);
	}
	
	
	//public Color brighter(){
	//}
	
	//public Color darker(){
	//}
	
	public boolean equals(Object obj){
		return value == ((Color)obj).value;
	}
	
	public int getAlpha(){
		return android.graphics.Color.alpha(value);
	}
	
	public int getRed(){
		return android.graphics.Color.red(value);
	}
	
	public int getGreen(){
		return android.graphics.Color.green(value);
	}
	
	public int getBlue(){
		return android.graphics.Color.blue(value);
	}
	
	public static Color getHSBColor(float h, float s, float b){
		return new Color(HSBtoRGB(h * 360f, s, b));
	}
	
	public static int HSBtoRGB(float hue, float saturation, float brightness){
		float[] color = {hue * 360, saturation, brightness};
		return android.graphics.Color.HSVToColor(color);
	}
	
	public static float[] RGBtoHSB(int r, int g, int b, float[] hsbvals){
		int color = android.graphics.Color.rgb(r, g, b);
		android.graphics.Color.colorToHSV(color, hsbvals);
		hsbvals[0] /= 360f;
		float[] C = {hsbvals[0], hsbvals[1], hsbvals[2]};
		return C;
	}
	
	//public String toString(){
	//}
	
	int getAndroidColor(){
		return value;
	}
}
