package greenfoot;

final class GameThread implements Runnable
{
    private boolean Alive = true;
	boolean isStopped = true;
	
	int delay;
	int speed;
	
	GameView view;
	World currentWorld;
	private Thread thread;
	
	GameTimer timer;
	
	GameThread(){
		thread = new Thread(this);
	}
	
	void init(){
		delay = 0;
		speed = 50;
		view = Greenfoot.view;
		currentWorld = Greenfoot.currentWorld;
	}
	
	void start(){
		setAlive(true);
		timer = new GameTimer();
		thread.start();
	}
	
	void setAlive(boolean b){
		Alive = b;
	}
	
    @Override
	public void run() {
		while (Alive) {
			float dt = timer.getTimeSecounds();
			if(dt > 1f / speed - 0.01f){
				timer.remark();
				Greenfoot.loadRecord();
				if(Greenfoot.Running){
					if(delay > 0)
					delay--;
					else{
						Greenfoot.getLastRelatedActor();
						if(Greenfoot.debug)
						try{
							logic(dt);
						}
						catch(Exception e){
							Greenfoot.addErrLines(e);
							Greenfoot.stop();
						}
						else
						logic(dt);
					}
				}
				view.draw();
				//System.gc();
			}
			thread.yield();
		}
	}
	
	public void logic(float dt) {
		if(isStopped){
			currentWorld.started();
			isStopped = false;
		}
		
		currentWorld.act0(dt);
		if(!currentWorld.actorList.isEmpty())
			for(int i = 0; i < currentWorld.actList.size(); i++) {
				(currentWorld.actList.get(i)).act0(dt);
			}
		}
}
