package greenfoot;

import android.view.MotionEvent;

public class MouseInfo
{
    float x;
	float y;
	
	boolean isTouching;
	boolean isSingleTapped;
	boolean isDoubleTapped;
	boolean isDragged;
	boolean isDragging;
	boolean isDragEnded;
	boolean isLongPressed;
	boolean isEntered;
	boolean isReleased;
	boolean isOutOfWorld;
	
	int buttonNum;
	int clickCount;
	Actor RelatedActor;
	MotionEvent lastEvent;
	
	
	MouseInfo(){
		x = 0;
		y = 0;
		
		if(Greenfoot.touchManager.currentMouseInfo != null){
			isTouching = Greenfoot.touchManager.currentMouseInfo.isTouching;
			isDragged = Greenfoot.touchManager.currentMouseInfo.isDragged;
		}
		else
		{
			isTouching =false;
			isDragged = false;
		}
		isSingleTapped = false;
		isDoubleTapped = false;
		isLongPressed = false;
		isDragEnded = false;
		isEntered = false;
		isReleased = false;
		
		buttonNum = 1;
		clickCount = 0;
		RelatedActor = null;
		lastEvent = null;
	}
	
	public Actor getActor(){
		return RelatedActor;
	}
	
	public int getClickCount(){
		int clickCount = 0;
		if(isSingleTapped)
			clickCount = 1;
		if(isDoubleTapped)
			clickCount = 2;
		return clickCount;
	}
	
	public int getButton(){
		return 1;
	}
	
	public int getX(){
		return Math.round(x);
	}
	public float getXF(){
		return x;
	}
	
	public int getY(){
		return Math.round(y);
	}
	public float getYF(){
		return y;
	}
	
	@Override
	public String toString(){
		return "MouseInfo. Actor: " + RelatedActor + "  Location: (" + x + "," + y + ")  Button: " + buttonNum + " Click Count: " + clickCount;
	}
}
