package stargate;

import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

public class Death_Glider extends Enemies
{
    private int speed = 4;
    private int hp = 100;
    private boolean shootDown;
    private boolean initiated;

    public void setSpeed(int spd)
    {
        speed = spd;
    }

    /**
     * setting variables
     */
    public Death_Glider()
    {
        shootDown = true;
        initiated = false;
    }

    public void act() 
    {
        if(!initiated)
        {
            getImage().mirrorHorizontally();
            super.overlapping3();
            initiated = true;
        }

        try
        {
            try   
            {
                Endless endless = (Endless) getWorld();
                if(getX() > endless.jumper.getX() + 50)
                {
                    turnTowards(endless.jumper.getX(), endless.jumper.getY());
                }
            }  catch(ClassCastException ex)
            {
                Level level = (Level) getWorld();
                if(getX() > level.jumper.getX() + 50)
                {
                    turnTowards(level.jumper.getX(), level.jumper.getY());
                }
            }
        } catch(IllegalStateException as)
        {
            setRotation(180);
        }

        if(touches(N_bomb.class))
        {
            getWorld().addObject(new Naquadah_Explosion(), getX(), getY());
            remove(N_bomb.class);
            die();
        } else if(touches(Naquadah_Explosion.class))
        {
            die();
        } else if(touches(F302_bullet.class))
        {
            die();
        }else 
        {
            if(touches(Drone.class))
            {
                remove(Drone.class);
                hp = hp - Drone.damage;
            }
            if(hp < 10)
            {
                die();
            } else
            {
                if(getX() > 1)
                {
                    move(speed);
                    int shoot = Greenfoot.getRandomNumber(50);
                    if(shoot == 2)
                    {
                        if(shootDown)
                        {
                            getWorld().addObject(new Death_Glider_staff(), getX(), getY() + 20);
                            shootDown = false;
                        } else
                        {
                            getWorld().addObject(new Death_Glider_staff(), getX(), getY() - 20);   
                            shootDown = true;
                        }
                    }
                } else
                {
                    getWorld().removeObject(this);
                }
            }
        }
    }

    /**
     * death with chance to make powerups
     */
    private void die()
    {
        int heavyAmmo = Greenfoot.getRandomNumber(20) + 1;
        switch(heavyAmmo)
        {
            case 7: getWorld().addObject(new HeavyAmmo(), getX(), getY());
        }
        try
        {
            Endless endless = (Endless) getWorld(); 
            endless.addScore(10);
        } catch(ClassCastException es) {}
        getWorld().addObject(new Explosion(200), getX(), getY());
        getWorld().removeObject(this);
    }
}
